L2. Maximum Points You Can Obtain from Cards | 2 Pointers and Sliding Window Playlist

  Рет қаралды 103,981

take U forward

take U forward

Күн бұрын

Пікірлер: 117
@Gottastudyhard-m3b
@Gottastudyhard-m3b 8 ай бұрын
Implementing it yourself makes it much more clearer.
@4444-c4s
@4444-c4s 8 ай бұрын
East or West, Striver bhaiya sabse Best KZbin pe esa koi bhi nahi hoga jo job ke saath saath itna content banata ho aur apni company bhi chalata ho...🙏🙏🙏
@Coder_Buzz07
@Coder_Buzz07 7 ай бұрын
codewithmik bhi hai bro
@Amanh729
@Amanh729 6 ай бұрын
@@Coder_Buzz07 yup
@adarshnegi8906
@adarshnegi8906 2 ай бұрын
This was a great problem, i hope one day i can come up with such approach all by myself. For those who might of two pointers i at 0 and j at n-1 and compare instances , this method will fail on TC such as [11,49,100,20,86,29,72], because at first it looks 72 should be chosen but all the elements after 11 are large and they will compensate and produce maximum score
@sruthimajhi5610
@sruthimajhi5610 17 күн бұрын
Thank you... I was dying to understand the problem statement. Now this example makes it easier why a sliding window approach should be used and not the two pointer approach.
@ritik_deswal77
@ritik_deswal77 21 күн бұрын
my approach using while loop in java - int[] ar= {6,2,3,4,7,2,1,7,1}; int k=4; int sum=0; for(int i=0;iar.length-k-1) { sum+=ar[l]; sum-=ar[r]; maxx=Math.max(maxx,sum); l--;r--; } System.out.println(maxx);
@mayanksaurabhmayanksaurabh9271
@mayanksaurabhmayanksaurabh9271 6 ай бұрын
thanks for so easy and intuitive solution. Lot of solutions for this problem are problem which have made it look really complex
@unknown2698
@unknown2698 5 ай бұрын
public static int maxScore(int[] cardPoints, int k) { int lsum =0, rsum =0, max =0,sum =0; int n = cardPoints.length; for(int i=0;imax){ max = sum; } } return max; } same approach but easier to understand
@VarshaSingh-hi2sb
@VarshaSingh-hi2sb 2 ай бұрын
In this case with above solution in video we can't take 7 i.e 7,2,1,7 which will result in more sum . or is it important to take the last card ?
@aakanshavishwakarma8235
@aakanshavishwakarma8235 6 ай бұрын
another approach? we can take a consecutive window of size (n-k) and find the minimum sum window , that yields us the maximum sum of the remaining 4 elements from the first or last
@akshaysharmaBSG
@akshaysharmaBSG 4 ай бұрын
Yes...that also makes sense...but what will be time complexity for getting min sum of n-k array size ?
@AryanGupta-2024
@AryanGupta-2024 4 ай бұрын
@@akshaysharmaBSG O(N) time and O(1) space
@sjain6320
@sjain6320 3 ай бұрын
@@AryanGupta-2024 yeah i did this but ig his solution is better as it is O(2k)
@time-barbaad
@time-barbaad 3 ай бұрын
@@sjain6320 the above said solution would be better in the cases where k > n/2
@parth_3856
@parth_3856 8 ай бұрын
OTHER CREATORS! be like "BHAI SAANS THO LENE DE......".
@109_debjitacharjee9
@109_debjitacharjee9 7 ай бұрын
u are the best bhaiya🤩 eagerly waiting for your string playlist
@KashishIsOn786
@KashishIsOn786 7 ай бұрын
Thank you @striver , for making DSA Easy for us . Hatts of to you .
@rushidesai2836
@rushidesai2836 3 ай бұрын
Classic problem.. thanks Striver!
@stith_pragya
@stith_pragya 6 ай бұрын
Understood...........Thank You So Much for this wonderful video..........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻
@IstiakGametube
@IstiakGametube 8 ай бұрын
I have been following your a2z DSA course. I want to do strings but there is no videos and problems in your sheet. Please make videos on them and upload the problems
@mrinceptionist7038
@mrinceptionist7038 7 ай бұрын
bro what are you talking about.....the a2z dsa sheet has 2 dedicated section for strings....step-5 and step-18, which covers all basics,medium and hard string questions !!!
@IstiakGametube
@IstiakGametube 7 ай бұрын
@@mrinceptionist7038 He has questions but there is no solve videos for them
@Codingforugeek
@Codingforugeek 8 ай бұрын
class Solution { public: int maxScore(vector& nums, int k) { int leftSum=0,rightSum=0,maxSum=0; for(int i=0;i=0;i--){ leftSum-=nums[i]; rightSum+=nums[rightIndex]; rightIndex--; maxSum=max(maxSum,leftSum+rightSum); } return maxSum; } }; here's the working code..... 😌
@bhaiinnaa6535
@bhaiinnaa6535 4 ай бұрын
You can take n-k as windowlength , totalsum=sum(arr) windowlength=n-k currwindowsum=sum(arr[:windowlength) maxwin=curwin , for l in range(windowlen,n): curwin +=arr[l]-arr[l-windowlen] netsum=total-curwin maxwin=max(maxwin,netsum)
@someThingisFishy5
@someThingisFishy5 4 ай бұрын
One more approach: As the qsn asking us to pickup the maximum points , and the points can be pickup either front or back side, (which leaves the least sum of points in the array) so we can find the minimum sum ,with window size n-k and subtract the result from total sum of the array ,we can use sliding window to solve this Time Complexity is O(N) Space Complexity is O(1)
@hashcodez757
@hashcodez757 3 ай бұрын
"UNDERSTOOD BHAIYA!!"
@ishanaggarwal7265
@ishanaggarwal7265 5 ай бұрын
Hi striver, I knew a better solution that solves in single pass.
@salehaafreen4309
@salehaafreen4309 3 ай бұрын
share it please
@subhasishdas3011
@subhasishdas3011 8 ай бұрын
One more approach is finding min_sum of all windows of size array_length - k , array_total_sum - min_sum will be the ans.
@sandeeppp9040
@sandeeppp9040 5 ай бұрын
class Solution { public int maxScore(int[] cardPoints, int k) { int lsum=0,rsum=0,maxSum=0; for(int i=0;i=0;i--){ lsum-=cardPoints[i]; rsum+=cardPoints[rindex]; rindex--; maxSum=Math.max(maxSum,(lsum+rsum)); } return maxSum; } } i was here and anyone can have this java code !!!! and also initial loop will go to end k because of correct calculation of lsum
@jivanmainali1742
@jivanmainali1742 2 ай бұрын
With modulo , its much easier class Solution { public: int maxScore(vector& cardPoints, int k) { int n = cardPoints.size(); int left = n-k; int right = n-k; int ans = 0; int sum = 0; while (left < n) { if ((right - left + 1)
@ted_mosby
@ted_mosby 3 ай бұрын
feels a little happy to solve this on my own
@torishi82
@torishi82 6 ай бұрын
Understood bhai. Thank you.
@vaibhavmurarka5179
@vaibhavmurarka5179 8 ай бұрын
my approach is similar to urs what i did is take k last elements followed by k first then i took sum of last k and then kept removing the front and adding the latest element in the sum and took max of these steps: int n=arr.size(); int ans=0; int sum=0; int ret=0; for(int i=n-k;i
@ShauryaPundir
@ShauryaPundir 8 ай бұрын
thanks vvvvv much sir,i really wanted a playlist like this
@tlasyashree7590
@tlasyashree7590 2 ай бұрын
Super easily understood
@8daudio672
@8daudio672 8 ай бұрын
class Solution { public int maxScore(int[] nums, int k) { //int left=0,right=0,maxi=0,sum=0; int n=nums.length,leftsum=0,rightsum=0,maxi=0; for(int i=0;i=0;i--){ leftsum-=nums[i];//contract //if(j>n-k-1) rightsum+=nums[j];//expand j--; maxi=Math.max(maxi,leftsum+rightsum); } return maxi; } } whats wong with it
@kisnagoyal9694
@kisnagoyal9694 7 ай бұрын
I think you are ignoring value of leftsum from (idx = 0 to idx=k-1) in maxi... So it doesn't take value of leftsum for first kth elements. So after the first loop try maxi = leftsum before going for second loop in which you are decreasing value of leftsum....try it...may help..
@lavanyaan2158
@lavanyaan2158 7 ай бұрын
Thank you so much for the video bro.
@hareshnayak7302
@hareshnayak7302 7 ай бұрын
Thanks striver for this amazing video.
@shivanshchaturvedi2601
@shivanshchaturvedi2601 11 күн бұрын
More of a two pointer approach rather than sliding window....as sliding window format is generally Diffrent.
@raghavmanish24
@raghavmanish24 5 ай бұрын
hey striver ... i'm the one of those follower who always give time for like and comment whenever i watch your videos.....thanku again
@AmanPandey-bd1sj
@AmanPandey-bd1sj 5 ай бұрын
thanks you bhaiya, Understood😊 import java.util.*; public class main{ public static void main(String args[]){ int a[] = {6, 2, 3, 4, 7, 2, 1, 7, 1}; int k = 4; System.out.println("MAX SUM IS: "+ findMaxPoints(a, k)); } public static int findMaxPoints(int a[], int k){ int lsum = 0; int rsum = 0; int maxsum = 0; for(int i=0;i
@ManishKumar-dk8hl
@ManishKumar-dk8hl 8 ай бұрын
JAVA BOLNE WALO K LIYE : -- class Solution { public int maxScore(int[] arr, int k) { int sum=0; for(int i=0;i
@bharath3387
@bharath3387 7 ай бұрын
Do we need seperate variables for right and left sum, can we not just maintain a single variable and 2 pointers and remove left pointer value and increase right bponter value
@LinhHoang-ml1qo
@LinhHoang-ml1qo 6 ай бұрын
understood!Thank you Striver
@sarangkumarsingh7901
@sarangkumarsingh7901 6 ай бұрын
Wow......nice approach......
@ShahNawaz-nk3po
@ShahNawaz-nk3po 6 ай бұрын
Another approach with is exactly same as one of the very standard Sliding window question. class Solution { public: int maxScore(vector& cardPoints, int k) { // we need to find substring of size (n-k) and minimum sum // final answer = is total sum of length n - minimum sum of substring of length (n-k) // = maximum sum of length k taken from extreme left/right int n = cardPoints.size(); int l = 0; int r = 0; int ans = INT_MAX; int sum = 0; int val = 0; for(auto it:cardPoints) val+=it; while(r(n-k)){ sum-=cardPoints[l]; l++; } if(r-l+1==(n-k)) ans = min(ans, sum); r++; } return val-ans; } };
@ganeshjaggineni4097
@ganeshjaggineni4097 5 ай бұрын
NICE SUPER EXCELLENT MOTIVATED
@iamnottech8918
@iamnottech8918 3 ай бұрын
Mja AAGeYa!!
@oyeesharme
@oyeesharme 3 ай бұрын
understood bhaiya
@mr_weird3680
@mr_weird3680 8 ай бұрын
Thanks Brother❤
@aditya_raj7827
@aditya_raj7827 4 ай бұрын
Understood 😊😊
@vamsilanka5639
@vamsilanka5639 4 ай бұрын
optimal solution in another way ------------------------------------------------------ public int maxScore(int[] arr, int k) { int n = arr.length; int i = 1, j = 1; int sum = 0,maxsum = -1; int end = 2 * k; /// to consider only first k and last k elements while (j k) { sum -= arr[(n + k - i) % n]; i++; } if ((j - i) + 1 == k) maxsum = Math.max(sum, maxsum); j++; } return maxsum; } ----------------------------------------
@jayateerthag.h5372
@jayateerthag.h5372 2 ай бұрын
Thankyou
@kshitijraj1320
@kshitijraj1320 8 ай бұрын
great video 😇
@kuldeeprawat-zp7od
@kuldeeprawat-zp7od 8 ай бұрын
Hello everyone, another approach we can think of is We can take sum of all the elements and as according to example we want sum of 4 maximum elements with given conditions and the size of array is 9 so actually we can calculate the sum of 5 consecutive elements which is minimum among all and then we can subtract it from the total sum of all the elements of the array
@naveenau143
@naveenau143 5 ай бұрын
Understood ❤
@subee128
@subee128 8 ай бұрын
Thank you very much
@codeman3828
@codeman3828 7 ай бұрын
Understood. Thanks
@Pushpraj-sf1nz
@Pushpraj-sf1nz 7 ай бұрын
it was helpful
@rishabsharma5307
@rishabsharma5307 4 ай бұрын
Started from the end and circularly rotated sliding window ``` int maxScore(vector& cardPoints, int k) { int i, j, maxSum, sum, n = cardPoints.size(); bool flag = false; i = j = n - k; maxSum = sum = 0; while(true) { sum += cardPoints[j]; if(j-i+1 == k || flag) { flag = true; maxSum = max(maxSum, sum); if(i == 0) break; sum -= cardPoints[i]; i = (i + 1) % n; } j = (j + 1) % n; } return maxSum; } ```
@adityapandey23
@adityapandey23 4 ай бұрын
Understood
@karthik-varma-1579
@karthik-varma-1579 2 ай бұрын
class Solution { public int maxScore(int[] cardPoints, int k) { long start = System.nanoTime(); int maxy = 0; int lsum = 0; int rsum = 0; for(int i=0;i=0;j--){ rsum = rsum + cardPoints[rightIndex]; rightIndex--; lsum = lsum - cardPoints[j]; maxy = Math.max(maxy,lsum+rsum); } long end = System.nanoTime(); System.out.println(end-start); return maxy; } }
@siddiqabr7110
@siddiqabr7110 29 күн бұрын
I thought of this approach at the very beginning and then thought of how to optimise this for an hour then came here to see the optimised approach but 😂😂😂😂😂😂 after coming here i realised I just wasted an hour
@ok-jg9jb
@ok-jg9jb 8 ай бұрын
Thanks❤
@prasannasahoo0806
@prasannasahoo0806 6 ай бұрын
what about the elements in the middle ? how do we reach them ?
@mihiradarsh7604
@mihiradarsh7604 6 ай бұрын
You are only allowed to take
@shototodoroki4719
@shototodoroki4719 8 ай бұрын
understood
@THAKURPRAJWALSINGH-o7o
@THAKURPRAJWALSINGH-o7o 6 ай бұрын
class Solution { public: int maxScore(vector& nums, int k) { int lsum=0; int rsum = 0; int maxSum = 0; int n = nums.size(); for(int i=0;i=0;i--){ lsum=lsum-nums[i]; rsum=rsum+nums[rindex]; rindex=rindex-1; maxSum= max(maxSum,lsum+rsum); } return maxSum; } };this code not passing testcases in leetcode
@ManishLakkavatri
@ManishLakkavatri 6 ай бұрын
the condition in the first loop will be i < k or i
@MuralidharanSrec
@MuralidharanSrec 2 ай бұрын
here that you have included all the elements as 4 size but the index 4 element 7 is not at all included if its included the output will be 17 am i correct
@thoughtsofkrishna8963
@thoughtsofkrishna8963 5 ай бұрын
We want Strings playlist Striver
@dipanshuraj7868
@dipanshuraj7868 Ай бұрын
can anyone guide me why the two pointer approach is not working here that I am place i in the 0 and the J = n-1;
@shreyxnsh.14
@shreyxnsh.14 Ай бұрын
this method will fail on TC such as [11,49,100,20,86,29,72], because at first it looks 72 should be chosen but all the elements after 11 are large and they will compensate and produce maximum score copied from another comment
@Prakash-jh7hp
@Prakash-jh7hp Ай бұрын
same approach but implemented in a simpler way class Solution { private static int sumupto(int k , int[]arr){ int res=0; for(int i =0;i
@jivanmainali1742
@jivanmainali1742 2 ай бұрын
Where is it mentoned to keep consecutive number
@sandeepgmore1483
@sandeepgmore1483 5 ай бұрын
@striver where can i get the source code solution for content
@angeldeveloper
@angeldeveloper 8 ай бұрын
🙌🏻
@paulbarsha1740
@paulbarsha1740 4 ай бұрын
Why 2*k and not 2+k? Isn't 2 separate loop takes adding and nested takes multiplication?
@sohaildarwajkar9979
@sohaildarwajkar9979 Ай бұрын
Bhai tu first year se wapas repeat kr
@jitghosh3923
@jitghosh3923 8 ай бұрын
🙌
@ShobhitVerma-j3f
@ShobhitVerma-j3f 2 ай бұрын
i think everyone is providing solution when N=2k+1, what if k is lesser than that??
@sanukyadav
@sanukyadav 6 ай бұрын
Understood, implementing with pseudocode is not able to pass leetcode test cases! did i miss something! def (nums, k): lsum = 0 maxsum = 0 n = len(nums) for i in range(k-1): lsum = lsum + nums[i] maxsum = lsum r_idx = n-1 maxsum = 0 rsum = 0 for i in range(k-1, -1, -1): lsum = lsum - nums[i] rsum = rsum + nums[r_idx-i] r_idx = r_idx - 1 maxsum = max(maxsum, lsum+rsum) return maxsum
@vatsalpoddar6660
@vatsalpoddar6660 5 ай бұрын
int maxScore(vector& cardPoints, int k) { int n = cardPoints.size(); int left = k-1; int right = n-1; int maxSum = INT_MIN; int sum = 0; for(int i = 0; i < k; i++){ sum += cardPoints[i]; } maxSum = max(maxSum, sum); while(left >= 0){ sum = sum - cardPoints[left]; sum = sum + cardPoints[right]; maxSum = max(maxSum, sum); left--; right--; } return maxSum; }
@Josuke217
@Josuke217 4 ай бұрын
You set maxsum to 0 and r_idx-i is wrong
@adityaroychowdhury3709
@adityaroychowdhury3709 8 ай бұрын
Subah uthe, aapke darshan hogye. Ab saare contest badia jayenge, sare hard question solve hone lag jayenge 😂😂
@dhruvmishra9781
@dhruvmishra9781 8 ай бұрын
bro konse year mein ho??
@theskyraturi
@theskyraturi Ай бұрын
hil bhi ni rhe ye questions mujhse
@DeorajMaharaj
@DeorajMaharaj 8 ай бұрын
bhaiya aap thora sick ya kaafi stressed lg rhe ho. Wo phle jaisa energy kahi na kahi missing laga.
@aryankumar3018
@aryankumar3018 3 ай бұрын
US
@StudyYuv
@StudyYuv 4 ай бұрын
😀😀
@manasandmohit
@manasandmohit 8 ай бұрын
Are bhaiya itni fast fast
@saketjaiswalSJ
@saketjaiswalSJ 7 ай бұрын
class Solution { public: int maxScore(vector& a, int k) { int n=a.size(); int s1=0; int s2=0; int i=0; int j=n-k; while(j k. tk loop chala k times o(k) { s2=s2+a[j]; j++; } int maxi = s2; j=n-k; while(i
@SibiRanganathL
@SibiRanganathL 3 ай бұрын
Understood
@ramakrishnakcr4417
@ramakrishnakcr4417 8 ай бұрын
understood
@aloklaha8694
@aloklaha8694 2 ай бұрын
Understood
@raghavmanish24
@raghavmanish24 5 ай бұрын
understood
@anshsaxena7297
@anshsaxena7297 16 күн бұрын
Understood
@AkashJaiswal-w4q
@AkashJaiswal-w4q 4 ай бұрын
understood
@riaa55
@riaa55 5 күн бұрын
Understood
@MJBZG
@MJBZG 3 ай бұрын
understood
L1. Introduction to Sliding Window and 2 Pointers | Templates | Patterns
36:55
Smart Sigma Kid #funny #sigma
00:33
CRAZY GREAPA
Рет қаралды 27 МЛН
Don't underestimate anyone
00:47
奇軒Tricking
Рет қаралды 25 МЛН
L4. Max Consecutive Ones III | 2 Pointers and Sliding Window Playlist
29:58
Beat Ronaldo, Win $1,000,000
22:45
MrBeast
Рет қаралды 28 МЛН
2 Years of C++ Programming
8:20
Zyger
Рет қаралды 8 М.
L5. Fruit Into Baskets | 2 Pointers and Sliding Window Playlist
30:02
take U forward
Рет қаралды 83 М.
5 Simple Steps for Solving Any Recursive Problem
21:03
Reducible
Рет қаралды 1,2 МЛН